/******************************************************************************/
/* Sistemas Integrados TECNISA                                                */
/*                                                                            */
/* Compras e Suprimentos                                                      */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/* Nome: APURA_LISTA                                                          */
/*                                                                            */
/* Descrio:                                                                 */
/* APURA AS MELHORES COTACOES PARA A LISTA DE PRECOS                          */
/*                                                                            */
/*                                                                            */
/* Criao:                                                                   */
/* 03/04/2000 - Yoris L. de Souza                                             */
/*                                                                            */
/* Manutenes:                                                               */
/* 08/05/2000 -  Adriano de Arajo                                            */
/*  Foi acrescentada verficaco para o tipo de fornecedor                     */
/*                                                                            */
/*                                                                            */
/******************************************************************************/

/******************************************************************************/
/* PARAMETROS:                                                                */
/*                                                                            */
/******************************************************************************/

/* @C:\WIN_PRJ\SQL\ORACLE\8290_SUPSTP_APURA_LISTA.SQL                         */

CREATE OR REPLACE PROCEDURE APURA_LISTA
(
  P_CDFILIAL     IN FILIAL.CDFILIAL%TYPE,
  P_NRSEQPRELIST IN PREVLISTA.NRSEQPRELIST%TYPE
)
IS
  V_CDPRODESTO   PRODUTO.CDPRODESTO%TYPE;
  V_CDPRODESTAUX PRODUTO.CDPRODESTO%TYPE;
  V_NRCOTESCAUTO NUMBER;
  V_VRPRECO      NUMBER;
  V_CDPRODUTO    PRODUTO.CDPRODUTO%TYPE;
  V_CDMARCA      MARCA.CDMARCA%TYPE;
  V_CDFORNECED   FORNECEDOR.CDFORNECED%TYPE;
  V_CDREGIAO     REGIAO.CDREGIAO%TYPE;
  V_CDREGIAOAUX  REGIAO.CDREGIAO%TYPE;
  V_NRCOLEPRECO  COLETAPR.NRCOLEPRECO%TYPE;

  V_NRCONTA      NUMBER;

  CURSOR C_COTACAO IS
  SELECT
     ITEMCOLE.CDPRODUTO, --PRODUTO.CDPRODESTO,
     DECODE(PARASUPRI.IDTIPOAPUR,
            NULL, (ITEMCOLE.VRPRECUNIITM / PRODUTO.VRFATOCONV),
            '1', ITEMCOLE.VRPRECECOITM,
            ITEMCOLE.VRPRECOITMPI),
     ITEMCOLE.NRCOLEPRECO,
     ITEMCOLE.CDPRODUTO,
     ITEMCOLE.CDMARCA,
     ITEMCOLE.CDFORNECED,
     ITEMCOLE.CDREGIAO
  FROM
     PRODUTO,
     FORNECEDOR,
     ITEMCOLE,
     PARASUPRI,
     ITMPREVLIST
  WHERE
     PARASUPRI.CDFILIAL       = P_CDFILIAL            AND
     ITMPREVLIST.CDFILIAL     = P_CDFILIAL            AND
     ITMPREVLIST.NRSEQPRELIST = P_NRSEQPRELIST        AND
     ITMPREVLIST.CDPRODUTO    = PRODUTO.CDPRODUTO      AND
     ITMPREVLIST.CDFORNECED   = FORNECEDOR.CDFORNECED  AND
     ITMPREVLIST.CDFILIAL     = ITEMCOLE.CDFILIAL      AND
     ITMPREVLIST.NRCOLEPRECO  = ITEMCOLE.NRCOLEPRECO   AND
     ITMPREVLIST.CDFORNECED   = ITEMCOLE.CDFORNECED    AND
     ITMPREVLIST.CDREGIAO     = ITEMCOLE.CDREGIAO      AND
     ITMPREVLIST.CDPRODUTO    = ITEMCOLE.CDPRODUTO     AND
     ITMPREVLIST.CDMARCA      = ITEMCOLE.CDMARCA       AND
     FORNECEDOR.IDTIPOFORN    = 'N'                    AND
     FORNECEDOR.IDSITUCADA    = 'A'                    AND
     NOT EXISTS
       (SELECT  /* Retirando os fornecedores no-qualificados */
         QUALIFICACAO.CDQUALIF
        FROM
          QUALIFICACAO
        WHERE
          FORNECEDOR.CDQUALIF = QUALIFICACAO.CDQUALIF AND
         (FORNECEDOR.IDFORNAUTO = 'N') AND
         ((QUALIFICACAO.IDPERCOTCMP = '2') OR
          ( (PARASUPRI.IDULTIDTVALQ = 'D' AND
            TO_DATE(SYSDATE) > FORNECEDOR.DTVALQUALIF) OR
           (PARASUPRI.IDULTIDTVALQ = 'M' AND
            TO_DATE(SYSDATE) > LAST_DAY(FORNECEDOR.DTVALQUALIF)) ) ) ) AND
      NOT EXISTS
      (SELECT
          QFOMARPROD.CDMARCA
       FROM
          QFOMARPROD
       WHERE
         (QFOMARPROD.CDPRODUTO = PRODUTO.CDPRODUTO) AND
         (QFOMARPROD.CDMARCA   = ITMPREVLIST.CDMARCA) AND
         ((QFOMARPROD.IDAPRMARPRO = 'N' AND QFOMARPROD.IDAUTMARPRO = 'N') OR
          ((QFOMARPROD.IDAPRMARPRO = 'S') AND
             ((PARASUPRI.IDULTIDTVALQ = 'M' AND
               TO_DATE(SYSDATE) > LAST_DAY(QFOMARPROD.DTVALAPROVA) ) OR
              (PARASUPRI.IDULTIDTVALQ = 'D' AND
               TO_DATE(SYSDATE) > QFOMARPROD.DTVALAPROVA)) ) )) AND
      EXISTS
        (SELECT
           QFOMARPROD.CDMARCA
         FROM
           QFOMARPROD
         WHERE
           QFOMARPROD.CDPRODUTO = PRODUTO.CDPRODUTO AND
           QFOMARPROD.CDMARCA   = ITMPREVLIST.CDMARCA

         UNION

         SELECT
           PARASUPRI.CDMARCA
         FROM
           PARASUPRI
         WHERE
           PARASUPRI.CDFILIAL    = P_CDFILIAL AND
           (PARASUPRI.IDMARSEMQUA = 'N' OR PARASUPRI.IDMARSEMQUA IS NULL)) AND

      NOT EXISTS
        (SELECT
            QFOPRODFORN.CDPRODUTO
         FROM
            QFOPRODFORN,
            PARASUPRI
         WHERE
           PARASUPRI.CDFILIAL = P_CDFILIAL  AND
           (QFOPRODFORN.CDPRODUTO = PRODUTO.CDPRODUTO) AND
           (QFOPRODFORN.CDFORNECED= FORNECEDOR.CDFORNECED) AND
           ((QFOPRODFORN.IDFORNAPROV = 'N' AND QFOPRODFORN.IDFORNAUTOR = 'N') OR
            ((QFOPRODFORN.IDFORNAPROV = 'S') AND
               ((PARASUPRI.IDULTIDTVALQ = 'M' AND
                 TO_DATE(SYSDATE) > LAST_DAY(QFOPRODFORN.DTVALPRFORN)) OR
                (PARASUPRI.IDULTIDTVALQ = 'D' AND
                 TO_DATE(SYSDATE) > QFOPRODFORN.DTVALPRFORN)) ) ))

  ORDER BY
     ITEMCOLE.CDPRODUTO, --PRODUTO.CDPRODESTO,
     ITEMCOLE.CDREGIAO,
     DECODE(PARASUPRI.IDTIPOAPUR,
            NULL, (ITEMCOLE.VRPRECUNIITM / PRODUTO.VRFATOCONV),
            '1', ITEMCOLE.VRPRECECOITM,
            ITEMCOLE.VRPRECOITMPI);

BEGIN

  UPDATE ITMPREVLIST
   SET IDITMSELLIS  = 'N'
  WHERE
   ITMPREVLIST.CDFILIAL     = P_CDFILIAL      AND
   ITMPREVLIST.NRSEQPRELIST = P_NRSEQPRELIST;

  SELECT NRCOTESCAUTO INTO V_NRCOTESCAUTO
  FROM PARASUPRI
  WHERE
   CDFILIAL = P_CDFILIAL;

  IF V_NRCOTESCAUTO IS NULL THEN
    V_NRCOTESCAUTO := 0;
  END IF;

  OPEN C_COTACAO;
    FETCH C_COTACAO
    INTO V_CDPRODESTO,
         V_VRPRECO,
         V_NRCOLEPRECO,
         V_CDPRODUTO,
         V_CDMARCA,
         V_CDFORNECED,
         V_CDREGIAO;
  LOOP
    EXIT WHEN C_COTACAO%NOTFOUND;

    V_NRCONTA := 1;
    V_CDPRODESTAUX := V_CDPRODESTO;
    V_CDREGIAOAUX  := V_CDREGIAO;

    WHILE (V_CDPRODESTAUX = V_CDPRODESTO) AND
          (V_CDREGIAOAUX  = V_CDREGIAO)
    LOOP
      EXIT WHEN C_COTACAO%NOTFOUND;
      IF (V_NRCONTA <= V_NRCOTESCAUTO) OR (V_NRCOTESCAUTO = 0) THEN
         UPDATE ITMPREVLIST
         SET IDITMSELLIS  = 'S'
         WHERE
          ITMPREVLIST.CDFILIAL     = P_CDFILIAL      AND
          ITMPREVLIST.NRCOLEPRECO  = V_NRCOLEPRECO  AND
          ITMPREVLIST.NRSEQPRELIST = P_NRSEQPRELIST  AND
          ITMPREVLIST.CDFORNECED   = V_CDFORNECED    AND
          ITMPREVLIST.CDREGIAO     = V_CDREGIAO      AND
          ITMPREVLIST.CDPRODUTO    = V_CDPRODUTO     AND
          ITMPREVLIST.CDMARCA      = V_CDMARCA;
      END IF;
      FETCH C_COTACAO
      INTO V_CDPRODESTO,
           V_VRPRECO,
           V_NRCOLEPRECO,
           V_CDPRODUTO,
           V_CDMARCA,
           V_CDFORNECED,
           V_CDREGIAO;
      V_NRCONTA := V_NRCONTA + 1;
    END LOOP;
  END LOOP;
  CLOSE C_COTACAO;
END;
/
