function Dfs61000_TransmissaoNfse_Controller(Dfs61000_TransmissaoNfse_Service, MessageService, ScreenService, templateManager, restEngine, ZHPromise, General, Dfs61000_Consultalote_Controller, ZhFilterPreferences) {
    
    this.setFiltroOnEnterOnce = function(widget) {
        
        var filter = [{"name": "CDFILIAL", "operator": "=", "value": 'FILIAL_LOGADA'}];
        
        General.callRestEngine("df#/crud/filial", "FilterData", filter).then((success) => {
            var filial = success.dataset.filial[0];
            widget.currentRow.CDFILIEMIT = [filial.CDFILIAL];
            widget.currentRow.NMFILIEMIT = [filial.NMFILIAL];
            widget.currentRow.CDEMPRESA  = [filial.CDEMPRESA];
            widget.currentRow.CDINSCESTA = [filial.CDINSCESTA];
            widget.currentRow.CDINSCMUNI = [filial.CDINSCMUNI];
            this.filtraFilhosEmpresa(widget);
            this.setData(widget);
            templateManager.container.getWidget('wdgTransmissaoNfse').dataSourceFilter[0].value = widget.currentRow.CDEMPRESA;
            var row = Util.clone(widget.currentRow);
            ZhFilterPreferences.setOriginalFilter(widget.id, row);
            ZhFilterPreferences.openFilterWidget(widget, row);
            widget.currentRow = {};
        },
        (error) => {
            ZhFilterPreferences.openFilterWidget(widget);
        });
    };

    this.setData = function(widget) {
        var date = new Date();
        var primeiroDia = new Date(date.getFullYear(), date.getMonth(), 1);
        var ultimoDia = new Date(date.getFullYear(), date.getMonth() + 1, 0);
        primeiroDia = formatarData(primeiroDia);
        ultimoDia = formatarData(ultimoDia);
        widget.currentRow.DTENTRSAID = {start : primeiroDia, end : ultimoDia};
    };
    
    function formatarData(data) {
        var d = new Date(data),
        mes = '' + (d.getMonth() + 1),
        dia = '' + d.getDate(),
        ano = d.getFullYear();
    
        if (mes.length < 2) mes = '0' + mes;
        if (dia.length < 2) dia = '0' + dia;
    
        return [dia, mes, ano].join('/');
    }

    this.enviarLoteRps = function(widget) {
        let checkedRows      = widget.getCheckedRows();
        let valida    = false;
        let erros     = [];
        let sucessos  = [];
        let erro;
        let xmlErros  = '';
        let rowsEnviarLote = [];
        let rowProcessada = false;
        let rowsConsultarLote = [];

        checkedRows.forEach(function(checkedRow) {
            if (checkedRow.IDTRANSMISRPS != 4 && checkedRow.IDTRANSMISRPS != 5) {
                if(checkedRow.IDTRANSMISRPS != 2) {
                    rowsEnviarLote.push(checkedRow);
                }
                rowsConsultarLote.push(checkedRow);
                valida = true;
            }
            else rowProcessada = true;
        });
        
        if (valida != false) {
            Dfs61000_TransmissaoNfse_Service.montarLotes(rowsEnviarLote, 50).then((success) => {
                let lotes = success, chain = ZHPromise.when();
                lotes.forEach(lote => {
                    const enviaTrataLote = lote => Dfs61000_TransmissaoNfse_Service.enviarLoteRps(lote).then(
                        callback => console.log(callback),
                        error => {
                            if (error.data.messages) {
                                erro = error.data.error;
                                xmlErros += '\n'+error.data.messages[0].message;
                            }
                            else if (error.data.error && error.data.error !== 'Não foi possivel enviar o lote. Corriga os erros e tente novamente.') {
                                erros += error.data.error + ' ';
                            }
                            else {
                                erros = [...erros, ...error.data.dataset.erros];
                            }
                        }
                    );
                    chain = chain.then(() => enviaTrataLote(lote));
                });
                chain.then(() => {
                    console.log(sucessos);
                    let existeErro = false;
                    if (typeof erros === 'string') {
                        ScreenService.showMessage(erros);
                        ScreenService.hideLoader();
                        existeErro = true;
                    }
                    if(!Util.isEmptyOrBlank(erros)) {
                        this.openPopupErros(erros);
                        widget.reload();
                        existeErro = true;
                    }
                    if(!Util.isEmptyOrBlank(xmlErros)) {
                        existeErro = true;
                        ScreenService.confirmMessage("Ocorreu um erro ao enviar o(s) lote(s). <br>Deseja ver o XML de envio?", "warning", function(){
                            widget.unSelectAll();
                            setLocalVar("TRANSMISSAO_ERRO_XML", xmlErros);
                            setLocalVar("TRANSMISSAO_ERRO", erro);
                            ScreenService.openWindow("df_saida#dfs61000_erros_transmissao_nfse");
                        }, null);
                        widget.reload();
                    }
                    else if(!existeErro) {
                        widget.reload().then(() => {
                            let mensagem = (rowProcessada) ? "Processo realizado com sucesso. Notas já enviadas foram ignoradas." : "Processo realizado com sucesso.";
                            let startTime = moment.now();
                            ScreenService.confirmMessage(ScreenService.i18n(mensagem.concat('Deseja consultar o(s) lote(s)?')), 'question', (success) => {
                    		    let endTime = moment.now();
                    		    let time;
                    		    if(endTime - startTime <= 12000) time = 12000 - (endTime - startTime);
                    		    else time = 1;
                    		    if(!rowsEnviarLote[0]) time = 1;
                    			ScreenService.changeLoadingMessage("Consultando o lote");
                    			ScreenService.showLoader();
                			    this.callConsultaLote(rowsConsultarLote, time, widget);
                    		});
                        });
                    }
                    widget.unSelectAll();
                });
            });
        }  
        else {
            ScreenService.showMessage("Todas as notas marcadas já foram enviadas.");
        }
    };
    
    this.callConsultaLote = function(rows, timeOut, widget) {
        setTimeout(function() {
            General.callRestEngine('df_saida#/getLoteNotas', 'DataSet', [rows]).then(function(response) {
                Dfs61000_Consultalote_Controller.consultarLotes(response.dataset.getLoteNotas, true, widget, rows);
                widget.reload();
            },
            function(error) {
                ScreenService.hideLoader();
                widget.reload();
            });
        }, timeOut);
    };


    this.abrirWidgetCancelamento = function(widget) {
        var rows = widget.getCheckedRows();
        var valida = true;

        rows.forEach(function (linha) {
            if (linha.IDTRANSMISRPS != 4) {
                valida = false;
                return;
            }
        });

        if (valida == false) {
            ScreenService.showMessage("Uma das notas marcadas ainda não foi processada.");
        }
        else {
            var options = {
                "requestType": "Row",
                "row": {
                    "CDEMPRESA": widget.appliedFilter.FILTER_ROW.CDEMPRESA,
                    "CDINSCMUNI": widget.appliedFilter.FILTER_ROW.CDINSCMUNI
                }
            };
            
            restEngine.post("df_saida#/getEstadoMunicipioDeInscricaoMunicipal", options, function(success) {
                if (success.dataset) {
                    widget.widgets[0].isVisible = true;
                    ScreenService.openSwipe(widget.widgets[0]);
                    var dataSource = null;
                    var fieldMotivo = null;
                    
                    if (success.dataset.data.SGESTADO === "MG" && (success.dataset.data.CDMUNICIPIO === "4123" || success.dataset.data.CDMUNICIPIO === "4371")) {
                        dataSource = {
                            "data": [
                                {"VALUE": "1", "DESCRIPTION": "Erro na emissão"},
                                {"VALUE": "2", "DESCRIPTION": "Serviço não concluído"}
                            ]
                        };
                        
                        fieldMotivo = widget.widgets[0].getField("MOTIVO");
                        fieldMotivo.template = "field/select-native.html";
                        fieldMotivo.dataSource = dataSource;
                        fieldMotivo.valueField = "VALUE";
                        fieldMotivo.descriptionField = "DESCRIPTION";
                    }
                    else if (success.dataset.data.SGESTADO === "PR" && success.dataset.data.CDMUNICIPIO === "7777") {
                        dataSource = {
                            "data": [
                                {"VALUE": "1", "DESCRIPTION": "Erro na emissão"},
                                {"VALUE": "2", "DESCRIPTION": "Serviço não prestado"},
                                {"VALUE": "4", "DESCRIPTION": "Duplicidade da nota"}
                            ]
                        };
                        
                        fieldMotivo = widget.widgets[0].getField("MOTIVO");
                        fieldMotivo.template = "field/select-native.html";
                        fieldMotivo.dataSource = dataSource;
                        fieldMotivo.valueField = "VALUE";
                        fieldMotivo.descriptionField = "DESCRIPTION";
                    }
                    else if (success.dataset.data.SGESTADO === "SP" && success.dataset.data.CDMUNICIPIO === "6291") {
                        fieldMotivo = widget.widgets[0].getField("MOTIVO");
                        fieldMotivo.template = "field/text-edit.html";
                        fieldMotivo.dataSource = null;
                        fieldMotivo.valueField = null;
                        fieldMotivo.descriptionField = null;
                    }
                }
                else {
                    ScreenService.showMessage("Funções de NFS-e não habilitada para esse município.");
                }
                
            }, undefined, function(error) {
                console.log(error);
            });
        }
    };

    this.nfseAprovadas = function(rows){
        let nfse = [];
        rows.forEach(
            function(linha) {
                if(linha.IDSTATUS == "A"){
                    nfse.push(linha.NRNOTAFISC);
                }
            }
        );
        return nfse;
    };

    this.cancelarNotas = function(widget) {
        if (widget.isValid()) {
            var motivo = widget.currentRow.MOTIVO;
            var wdgTransmissao = templateManager.container.getWidget("wdgTransmissaoNfse");
            var rows = wdgTransmissao.getCheckedRows();
            var nfseAprovadas = this.nfseAprovadas(widget.getParent().getCheckedRows());
            
            if(nfseAprovadas.length == 0 || nfseAprovadas == null){
                
                rows.forEach(function(linha){
                    linha.MOTIVO = motivo;
                });
                
                var options = {
                    "requestType": "DataSet",
                    "dataset": rows
                };
                restEngine.post("df_saida#/cancelarNotas", options,
                    function (success) {
                        if (success.messages != undefined) {
                            ScreenService.showMessage(success.messages[0].message);
                            ScreenService.closeSwipe();
                            widget.currentRow.MOTIVO = null;
                            widget.isVisible = false;
                            wdgTransmissao.reload();
                        }
                        else {
                            ScreenService.showMessage(success);
                            console.log(success);
                        }
                    }, undefined,
                    function (error) {
                        ScreenService.showMessage("Ocorreu um erro inesperado.");
                        console.log(error);
                    }
                );
            } else{
                var textoMsg = "NAO_FOI_POSSIVEL_EFETUAR";
                var notas;
                nfseAprovadas.forEach(
                    function(numero){
                        notas += numero + ", ";
                    }
                );
                MessageService.showMessageByCode(textoMsg, {"NOTAS": notas.slice(0, -2)});
                ScreenService.closeSwipe();
            }
        }
    };

    this.consultaLotes = function() {
        ScreenService.openWindow("df_saida#dfs61000_consulta_lote");
    };

    this.filtraFilhosEmpresa = function(widget) {
        if(widget.currentRow.CDFILIEMIT.length != 0) {
            General.callRestEngine("df#/crud/filial", "FilterData", [{name: "CDFILIAL", operator: "IN", value: widget.currentRow.CDFILIEMIT}])
                .then((sucesso) => {
                    var filiais = sucesso.dataset.filial;
        
                    var cdempresa = filiais[0].CDEMPRESA;
                    var mostraMensagem = true;
                    var erroEmpresa = false;
                    if(typeof empresas != "string") {
                        filiais.forEach((filial) => {
                            if(filial.CDEMPRESA !== cdempresa) erroEmpresa = true; 
                        });
                    }
                    else if(widget.currentRow.NMFILIEMIT.length == 0) {
                        erroEmpresa = true;
                        mostraMensagem = false;
                    }
                    
                    if(erroEmpresa == true) {
                        if(mostraMensagem) ScreenService.showMessage("Unidades devem estar relacionadas a mesma empresa!");
                        widget.currentRow.CDFILIEMIT = [];
                        widget.currentRow.NMFILIEMIT = [];
                        widget.currentRow.CDEMPRESA  = [];
                        widget.currentRow.CDINSCESTA = [];
                        widget.currentRow.CDINSCMUNI = [];
                        widget.currentRow.CDSERIE    = '';
                    }
                    else {
                        widget.currentRow.CDEMPRESA  = filiais[0].CDEMPRESA;
                        widget.currentRow.CDINSCESTA = filiais[0].CDINSCESTA;
                        widget.currentRow.CDINSCMUNI = filiais[0].CDINSCMUNI;
                        
                        
                        var cdinscesta = filiais[0].CDINSCESTA;
                        var cdinscmuni = filiais[0].CDINSCMUNI;
                
                        var campo = widget.getField("CDINSCESTA");
                        campo.dataSourceFilter[0].value = cdempresa;
                        //campo.clearValue();
                        campo.reload();
                
                        campo = widget.getField("CDINSCMUNI");
                        campo.dataSourceFilter[0].value = cdempresa;
                        //campo.clearValue();
                        campo.reload();
                
                        campo = widget.getField("CDSERIE");
                        campo.dataSourceFilter[0].value = cdempresa;
                        campo.dataSourceFilter[1].value = cdinscesta;
                        campo.dataSourceFilter[2].value = cdinscmuni;
                        campo.clearValue();
                        campo.reload();
                    }
            });
        }
        else {
            widget.currentRow.CDFILIEMIT = [];
            widget.currentRow.NMFILIEMIT = [];
            widget.currentRow.CDEMPRESA  = [];
            widget.currentRow.CDINSCESTA = [];
            widget.currentRow.CDINSCMUNI = [];
            widget.currentRow.CDSERIE    = '';
        }
        widget.reload();
        
    };
    
    this.setFiltroEmpresa = function(args) {
        var widget = args.owner;
        args.e.preventDefault();
        var dataSourceFilter = [];
        dataSourceFilter = widget.dataSourceFilter.filter((data) =>  {
            if(data.name != 'NMFILIEMIT' && data.name != 'CDFILIEMIT' && data.value !== null) return data;
            
        });
        var cdfiliemit = widget.appliedFilter.FILTER_ROW.CDFILIEMIT;
        dataSourceFilter.push({name: "CDFILIEMIT", operator: "IN", value: cdfiliemit});
        widget.dataSource.clearCheckedRows();
        var filterCurrentRow = widget.appliedFilter.FILTER_ROW;
        widget.dataSourceFilter[0].value = filterCurrentRow.CDEMPRESA;
        widget.reload();
    };

    this.filtraFilhosInscricaoEstadual = function(widget) {
        var cdinscesta = widget.currentRow.CDINSCESTA;
        var campo = widget.getField("CDSERIE");
        campo.dataSourceFilter[1].value = cdinscesta;
        campo.clearValue();
        campo.reload();
    };

    this.filtraFilhosInscricaoMunicipal = function(widget) {
        var cdinscmuni = widget.currentRow.CDINSCMUNI;
        var campo = widget.getField("CDSERIE");
        campo.dataSourceFilter[2].value = cdinscmuni;
        campo.clearValue();
        campo.reload();
    };
    
    this.enviarEmail = function(widget) {
        var rows = widget.getCheckedRows();

        var valida = true;
    
        rows.forEach(function(linha) {
            if(!linha.NRSEQLOTERPS || linha.IDTRANSMISRPS !== '4') {
                valida = false;
            } 
        });
        
        if(!valida)ScreenService.showMessage('Uma ou mais notas selecionadas não foram processadas ou foram processadas com erro!');
        else {
            var options = {
                    "requestType": "DataSet",
                    "dataset": rows
            };
            restEngine.post("df_saida#/enviaEmailNota", options,
                function(success) {
                    if (success.messages && !success.error) {
                        ScreenService.successNotification('E-mail enviado com sucesso.');
                        widget.unSelectAll();
                        widget.reload();
                        ScreenService.closePopup();
                    }
                    else  if(success.error) {
                        ScreenService.errorNotification("Ocorreu um erro ao realizar o envio do e-mail. Contate o administrador do sistema.");
                        ScreenService.showMessage(success.error);
                    }
                    else {
                        ScreenService.showMessage(success);
                        widget.unSelectAll();
                    }
                }, undefined,
                function(error) {
                    if(typeof error.data.error[0] !== 'string') this.openPopupErros(error.data.error);
                    else ScreenService.showMessage(error.data.error);
                }.bind(this)
            );
        }
    };
    
    this.openSubstituicao = function() {
        ScreenService.openWindow("df_saida#dfs61000_substituicao_nfse");  
    };
    
    this.openPopupErros = function(erros) {
        var widgetErros = templateManager.container.getWidget('WidgetErros');
        
        if(!Array.isArray(erros)) erros = [erros];
        
        widgetErros.dataSource.data = erros;
        widgetErros.isVisible = true;
        ScreenService.openPopup(widgetErros);
        widgetErros.activate();
    };
    
    this.closeErros = function(widget) {
        widget.isVisible = false;
        widget.dataSource.data = [];
        ScreenService.closePopup(widget);
        widget.getParent().activate();
        widget.getParent().unSelectAll();
        widget.getParent().reload();
        ScreenService.closePopup();
    };
    
    this.openPopupNomeZipXML = function(widget) {
        var widgetNomeZip = templateManager.container.getWidget('WidgetNomeZip');
        widgetNomeZip.isVisible = true;
        ScreenService.openPopup(widgetNomeZip);
        widgetNomeZip.activate();
    };
    
    this.downloadXML = function(widget, row) {
        var widgetNomeZip = templateManager.container.getWidget('WidgetNomeZip');
        var rows = widget.getCheckedRows();
        if(row.NOMEZIP) {
            if(validaNomeArquivo(row.NOMEZIP)) {
                rows[0].nomezip = row.NOMEZIP;
                var valida = true;
        
                rows.forEach(function(linha) {
                    if(!linha.NRSEQLOTERPS || (linha.IDTRANSMISRPS !== '4' && linha.IDTRANSMISRPS !== '2')) {
                        valida = false;
                    }
                });
                
                if(valida === false) ScreenService.showMessage('Uma ou mais notas selecionadas não foram processadas.');
                else {
                    var options = {
                            "requestType": "DataSet",
                            "dataset": rows
                    };
                    restEngine.post("df_saida#/downloadXMLNfse", options,
                        function(success) {
                            this.downloadArquivo(success.dataset.nomeArquivo).then(function(){
                                widgetNomeZip.isVisible  = false;
                                widgetNomeZip.currentRow = {};
                                widget.activate();
                                widget.unSelectAll();
                                widget.reload();
                                ScreenService.goBack();
                                ScreenService.closePopup();
                                ScreenService.closePopup();
                            });
                            
                        }.bind(this), undefined,
                        function(error) {
                            if(typeof error.data.error[0] !== 'string') this.openPopupErros(error.data.error);
                            else ScreenService.showMessage(error.data.error);
                        }.bind(this)
                    );
                }
            }
            else ScreenService.showMessage('Nome do arquivo não pode conter os caracteres "<", "%", "|", "\\", "<", ">", "?", ":"');
        }
        else ScreenService.showMessage('Escolha um nome para o arquivo.');
    };
    
    this.downloadArquivo = function(fileName, message) {
        // Inicializa uma promise.
        var deferred = ZHPromise.defer();
        window.open(window.serviceUrls.filter(function(x){return x.package == 'df';})[0].baseUrl+"/downloadArquivo?requestType=Row&row[DSARQUIVO]="+fileName);

        // Finaliza a promise com sucesso.
        deferred.resolve();
       
        return deferred;
    };
    
    this.visualizarEspelhoNFSe = function(args){
        var nota = args.owner.widget.currentRow;

        if(nota.IDTRANSMISRPS == '4'){ // Se a nota for processada
            Dfs61000_TransmissaoNfse_Service.visualizarNFSe(nota).then(function(result){
                var fileUri = result.dataset.arquivo.DIRETORIO;
                this.downloadArquivo(fileUri);
                
            }.bind(this), function(error) {
                ScreenService.showMessage(error.data.error);
            }.bind(this));
        }
        else{
            ScreenService.showMessage("Esta nota não foi processada e autorizada.");
        }
    };
    
     this.downloadArquivo = function(nmArquivo){
        window.open(window.serviceUrls.filter(function(x){return x.package == 'df';})[0].baseUrl+"/downloadArquivo?requestType=Row&row[DSARQUIVO]=" + nmArquivo);
    };
    
    this.voltarNomeZip = function(widget) {
        widget.getParent().activate();
        ScreenService.closePopup();
    };
    
    function validaNomeArquivo(nome) {
        return ((nome.indexOf("<") == -1) && 
                (nome.indexOf("%") == -1) && 
                (nome.indexOf("|") == -1) && 
                (nome.indexOf("\\") == -1)&& 
                (nome.indexOf("/") == -1) && 
                (nome.indexOf("<") == -1) && 
                (nome.indexOf(">") == -1) && 
                (nome.indexOf("?") == -1) && 
                (nome.indexOf(" ") == -1) && 
                (nome.indexOf(":") == -1));
    }
    
    this.validaVisibilidadeActionCancelarNotas = function(args) {
        var actionCancelarNotas = args.owner.getAction("cancelar_notas"),
            filter = [{"name": "CDEMPRESA", "operator": "=", "value":  args.owner.appliedFilter.FILTER_ROW.CDEMPRESA},
                      {"name": "CDINSCMUNI", "operator": "=" , "value":  args.owner.appliedFilter.FILTER_ROW.CDINSCMUNI}
                     ];
                     
        General.callRestEngine("df#/crud/inscrmunicip_municipio", "FilterData", filter).then( (callback) => {  
            
            if(callback.dataset.inscrmunicip_municipio[0]) {
                if(callback.dataset.inscrmunicip_municipio[0].CDMUNICIPIO == '3849') {
                    actionCancelarNotas.isVisible = false;
                } else {
                    actionCancelarNotas.isVisible = true;
                }
            }    
        });
    };

}

Configuration(function (ContextRegister) {
    ContextRegister.register("Dfs61000_TransmissaoNfse_Controller", Dfs61000_TransmissaoNfse_Controller);
});
